Coin: SoSceneTexture2 Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | List of all members
SoSceneTexture2 Class Reference
Node Classes

The SoSceneTexture2 class is used to create a 2D texture from a Coin scene graph. More...

`#include <Inventor/nodes/SoSceneTexture2.h>`

Inheritance diagram for SoSceneTexture2:

## Public Types
enum | Model { MODULATE = SoMultiTextureImageElement::MODULATE , DECAL = SoMultiTextureImageElement::DECAL , BLEND = SoMultiTextureImageElement::BLEND , REPLACE = SoMultiTextureImageElement::REPLACE }
enum | Wrap { REPEAT = SoMultiTextureImageElement::REPEAT , CLAMP = SoMultiTextureImageElement::CLAMP , CLAMP_TO_BORDER = SoMultiTextureImageElement::CLAMP_TO_BORDER }
enum | TransparencyFunction { NONE , ALPHA_BLEND , ALPHA_TEST }
enum | Type { DEPTH , RGBA8 , RGBA32F , RGB32F , RGBA16F , RGB16F , R3_G3_B2 , RGB , RGB4 , RGB5 , RGB8 , RGB10 , RGB12 , RGB16 , RGBA , RGBA2 , RGBA4 , RGB5_A1 , RGB10_A2 , RGBA12 , RGBA16 }
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 , INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 , COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 , COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 , COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000 }

## Public Member Functions
virtual SoType | getTypeId (void) const
virtual void | notify (SoNotList *list)
virtual void | write (SoWriteAction *action)
virtual void | doAction (SoAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | callback (SoCallbackAction *action)
virtual void | rayPick (SoRayPickAction *action)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | handleEvent (SoHandleEventAction *action)
virtual void | pick (SoPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
virtual void | startNotify (void)
SbUniqueId | getNodeId (void) const
virtual SoChildList * | getChildren (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoNode * | addToCopyDict (void) const
virtual void | copyContents (const SoFieldContainer *from, SbBool copyconnections)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes
SoSFEnum | wrapS
SoSFEnum | wrapT
SoSFEnum | model
SoSFColor | blendColor
SoSFVec4f | backgroundColor
SoSFVec2s | size
SoSFNode | scene
SoSFNode | sceneTransparencyType
SoSFEnum | transparencyFunction
SoSFEnum | type
Public Attributes inherited from SoBase

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Additional Inherited Members
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoSceneTexture2 class is used to create a 2D texture from a Coin scene graph.

Lets the rendering of a scene graph be specified as a texture image to be used in another scene graph. Set up the scene graph used for a texture in the SoSceneTexture2::scene field.

This node behaves exactly like SoTexture2 when it comes mapping the actual texture onto subsequent geometry. Please read the SoTexture2 documentation for more information about how textures are mapped onto shapes.

A notable feature of this node is that it will use offscreen pbuffers for hardware accelerated rendering, if they are available from the OpenGL driver. WGL, GLX and AGL, for OpenGL drivers on Microsoft Windows, X11 and Mac OS X, respectively, all support the OpenGL Architecture Review Board (ARB) pbuffer extension in later incarnations from most OpenGL vendors.

Note also that the offscreen pbuffer will be used directly on the card as a texture, with no costly round trip back and forth from CPU memory, if the OpenGL driver supports the recent ARB_render_texture extension.

An important limitation is that textures should have dimensions that are equal to a whole power-of-two, see documentation for SoSceneTexture::size.

FILE FORMAT/DEFAULTS:

SceneTexture2 {
size 256 256
scene NULL
sceneTransparencyType NULL
type RGBA_UNSIGNED_BYTE
backgroundColor 0 0 0 0
transparencyFunction NONE
wrapS REPEAT
wrapT REPEAT
model MODULATE
blendColor 0 0 0
}
SoSceneTexture2::NONE
@ NONE
Definition SoSceneTexture2.h:70
SoSceneTexture2::wrapS
SoSFEnum wrapS
Definition SoSceneTexture2.h:101
SoSceneTexture2::MODULATE
@ MODULATE
Definition SoSceneTexture2.h:57
SoSceneTexture2::blendColor
SoSFColor blendColor
Definition SoSceneTexture2.h:104
SoSceneTexture2::backgroundColor
SoSFVec4f backgroundColor
Definition SoSceneTexture2.h:106
SoSceneTexture2::type
SoSFEnum type
Definition SoSceneTexture2.h:112
SoSceneTexture2::model
SoSFEnum model
Definition SoSceneTexture2.h:103
SoSceneTexture2::wrapT
SoSFEnum wrapT
Definition SoSceneTexture2.h:102
SoSceneTexture2::REPEAT
@ REPEAT
Definition SoSceneTexture2.h:64
SoSceneTexture2::scene
SoSFNode scene
Definition SoSceneTexture2.h:108
SoSceneTexture2::sceneTransparencyType
SoSFNode sceneTransparencyType
Definition SoSceneTexture2.h:109
SoSceneTexture2::transparencyFunction
SoSFEnum transparencyFunction
Definition SoSceneTexture2.h:110
SoSceneTexture2::size
SoSFVec2s size
Definition SoSceneTexture2.h:107

Since
  Coin 2.2

## Member Enumeration Documentation

## ◆ Model

enum SoSceneTexture2::Model

Texture mapping model, for deciding how to "merge" the texture map with the object it is mapped onto.

Enumerator
MODULATE | Texture color is multiplied by the polygon color. The result will be Phong shaded (if light model is PHONG).
DECAL | Texture image overwrites polygon shading. Textured pixels will not be Phong shaded. Has undefined behaviour for grayscale and grayscale-alpha textures.
BLEND | This model is normally used with monochrome textures (i.e. textures with one or two components). The first component, the intensity, is then used to blend between the shaded color of the polygon and the SoSceneTexture2::blendColor.
REPLACE | Texture image overwrites polygon shading. Textured pixels will not be Phong shaded. Supports grayscale and grayscale alpha textures. This feature requires OpenGL 1.1. MODULATE will be used if OpenGL version < 1.1 is detected.

## ◆ Wrap

enum SoSceneTexture2::Wrap

Enumeration of wrapping strategies which can be used when the texture map doesn't cover the full extent of the geometry.

Enumerator
REPEAT | Repeat texture when coordinate is not between 0 and 1.
CLAMP | Clamp coordinate between 0 and 1.
CLAMP_TO_BORDER | Clamp coordinate to range [1/2N, 1 - 1/2N], where N is the size of the texture in the direction of clamping.

## ◆ TransparencyFunction

enum SoSceneTexture2::TransparencyFunction

For deciding how the texture's alpha channel is handled. It's not possible to automatically detect this, since the texture is stored only on the graphics card's memory, and it'd be too slow to fetch the image to test the alpha channel like Coin does for regular textures.

Enumerator
NONE | The alpha channel is ignored.
ALPHA_BLEND | Alpha blending is used.
ALPHA_TEST | An alpha test function is used.

## ◆ Type

enum SoSceneTexture2::Type

Enumerator
DEPTH | Specifies a depth buffer texture.
RGBA8 | Specifies an RGBA texture with 8 bits per component.
RGBA32F | Specifies a RGBA texture with floating point components.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoSceneTexture2::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getTypeId()

SoType SoSceneTexture2::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Implements SoBase.

## ◆ getFieldDataPtr()

const SoFieldData ** SoSceneTexture2::getFieldDataPtr | ( | void |  | ) |
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## ◆ getFieldData()

const SoFieldData * SoSceneTexture2::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoFieldContainer.

## ◆ notify()

void SoSceneTexture2::notify | ( | SoNotList * | l | ) |
| virtual

Notifies all auditors for this instance when changes are made.

Reimplemented from SoNode.

## ◆ write()

void SoSceneTexture2::write | ( | SoWriteAction * | action | ) |
| virtual

Action method for SoWriteAction.

Writes out a node object, and any connected nodes, engines etc, if necessary.

Reimplemented from SoNode.

## ◆ doAction()

void SoSceneTexture2::doAction | ( | SoAction * | action | ) |
| virtual

This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

## ◆ GLRender()

void SoSceneTexture2::GLRender | ( | SoGLRenderAction * | action | ) |
| virtual

Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

## ◆ callback()

void SoSceneTexture2::callback | ( | SoCallbackAction * | action | ) |
| virtual

Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

## ◆ rayPick()

void SoSceneTexture2::rayPick | ( | SoRayPickAction * | action | ) |
| virtual

Action method for SoRayPickAction.

Checks the ray specification of the action and tests for intersection with the data of the node.

Nodes influencing relevant state variables for how picking is done also override this method.

Reimplemented from SoNode.

## Member Data Documentation

## ◆ wrapS

SoSFEnum SoSceneTexture2::wrapS

Wrapping strategy for the S coordinate when the texture map is narrower than the object to map onto.

Default value is SoSceneTexture2::REPEAT.

## ◆ wrapT

SoSFEnum SoSceneTexture2::wrapT

Wrapping strategy for the T coordinate when the texture map is shorter than the object to map onto.

Default value is SoSceneTexture2::REPEAT.

## ◆ model

SoSFEnum SoSceneTexture2::model

Texture mapping model for how the texture map is "merged" with the polygon primitives it is applied to. Default value is SoSceneTexture2::MODULATE.

## ◆ blendColor

SoSFColor SoSceneTexture2::blendColor

Blend color. Used when SoSceneTexture2::model is SoSceneTexture2::BLEND.

Default color value is [0, 0, 0], black, which means no contribution to the blending is made.

## ◆ backgroundColor

SoSFVec4f SoSceneTexture2::backgroundColor

The color the color buffer is cleared to before rendering the scene. Default value is (0.0f, 0.0f, 0.0f, 0.0f).

## ◆ size

SoSFVec2s SoSceneTexture2::size

The size of the texture.

This node currently only supports power of two textures. If the size is not a power of two, the value will be rounded upwards to the next power of two.

## ◆ scene

SoSFNode SoSceneTexture2::scene

The scene graph that is rendered into the texture.

## ◆ sceneTransparencyType

SoSFNode SoSceneTexture2::sceneTransparencyType

Used for overriding the transparency type for the sub scene graph. Should contain an instance of the SoTransparencyType node, or NULL to inherit the transparency type from the current viewer.

Please note that if you want to render the texture using frame buffer objects, you need to use of of the NONE, SCREEN_DOOR, ADD or BLEND transparency types.

## ◆ transparencyFunction

SoSFEnum SoSceneTexture2::transparencyFunction

The transparency function used. Default value is NONE.

## ◆ type

SoSFEnum SoSceneTexture2::type

The type of texture to generate. RGBA8 for normal texture, DEPTH for a depth buffer texture, RGBA32F for a floating point RGBA texture. texture. Default is RGBA_UNSIGNED_BYTE.

The documentation for this class was generated from the following files:

- SoSceneTexture2.h
- SoSceneTexture2.cpp